package net.pleus.services.calculator.api;

import  net.pleus.services.calculator.api.model.CalculatorError;

public class CalculatorException extends RuntimeException {

	public static final int ERROR_UNKNOWN = 0;
	public static final int ERROR_TRANSACTIONREQUIRED = 1;
	public static final int ERROR_DIVISIONBYZERO = 999;

	private CalculatorError error;

	private static final long serialVersionUID = 1L;

	public CalculatorException(){
	}
	
	public CalculatorException(String message, Throwable exception, CalculatorError error){
		super(message, exception);
		this.error = error;
	}

	public CalculatorException(String message){
		super(message);
		this.error = new CalculatorError(message,ERROR_UNKNOWN);
	}

	public CalculatorException(Throwable e){
		super(e);
		this.error = new CalculatorError(e.getMessage(),ERROR_UNKNOWN);
	}

	public CalculatorException(String message, Throwable e){
		super(e);
		this.error = new CalculatorError(e.getMessage(),ERROR_UNKNOWN);
	}

	public CalculatorException(String message, int code, Throwable e){
		super(e);
		this.error = new CalculatorError(message,code);
	}
	
	public CalculatorError getError() {
		return error;
	}

	public void setError(CalculatorError error) {
		this.error = error;
	}

}
