package net.pleus.services.calculator.restclient;

import java.io.IOException;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.client.ClientRequestContext;
import javax.ws.rs.client.ClientResponseContext;
import javax.ws.rs.client.ClientResponseFilter;
import javax.ws.rs.core.Response;
import javax.ws.rs.ext.Provider;

import org.codehaus.jackson.map.ObjectMapper;

import net.pleus.services.calculator.api.model.CalculatorError;
import net.pleus.services.calculator.api.CalculatorException;

@Provider
public class ServiceExceptionFilter  implements ClientResponseFilter  {

    private static ObjectMapper _MAPPER = new ObjectMapper();

	@Override
	public void filter(ClientRequestContext requestContext, ClientResponseContext responseContext) throws IOException {
		if (responseContext.getStatus() == Response.Status.INTERNAL_SERVER_ERROR.getStatusCode()){
			CalculatorError error = _MAPPER.readValue(responseContext.getEntityStream(), CalculatorError.class);
			CalculatorException exception = new CalculatorException(error.getMessage());
			exception.setError(error);
			throw new WebApplicationException(exception);
		}
	}
}
