package net.pleus.services.calculator.binding.jsonhttp;

import org.springframework.stereotype.Component;
import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.ResponseBody;

import net.pleus.services.calculator.api.Calculator;
import net.pleus.services.calculator.api.CalculatorException;
import net.pleus.services.calculator.api.model.PerformCalculationsRequest;
import net.pleus.services.calculator.api.model.PerformCalculationsResponse;

@RestController
@RequestMapping(value = "/services/calculator/rest/api")
public class CalculatorJSONHTTPBinding {

    @Autowired
    private Calculator service;

    @RequestMapping(value = "/performcalculations", method= RequestMethod.POST)
    @ResponseBody
    public PerformCalculationsResponse performCalculations(@RequestBody PerformCalculationsRequest request) {
        return service.performCalculations(request);
    }
}